/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the ClonedTemplate type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ClonedTemplate{}

// ClonedTemplate struct for ClonedTemplate
type ClonedTemplate struct {
	Id string `json:"id"`
	Name string `json:"name"`
	// Id of template from which it was created
	SourceId string `json:"source_id"`
	GatewayId string `json:"gateway_id"`
	ChannelId string `json:"channel_id"`
	SourceGatewayId string `json:"source_gateway_id"`
}

// NewClonedTemplate instantiates a new ClonedTemplate object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewClonedTemplate(id string, name string, sourceId string, gatewayId string, channelId string, sourceGatewayId string) *ClonedTemplate {
	this := ClonedTemplate{}
	this.Id = id
	this.Name = name
	this.SourceId = sourceId
	this.GatewayId = gatewayId
	this.ChannelId = channelId
	this.SourceGatewayId = sourceGatewayId
	return &this
}

// NewClonedTemplateWithDefaults instantiates a new ClonedTemplate object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewClonedTemplateWithDefaults() *ClonedTemplate {
	this := ClonedTemplate{}
	return &this
}

// GetId returns the Id field value
func (o *ClonedTemplate) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *ClonedTemplate) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *ClonedTemplate) SetId(v string) {
	o.Id = v
}

// GetName returns the Name field value
func (o *ClonedTemplate) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *ClonedTemplate) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *ClonedTemplate) SetName(v string) {
	o.Name = v
}

// GetSourceId returns the SourceId field value
func (o *ClonedTemplate) GetSourceId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.SourceId
}

// GetSourceIdOk returns a tuple with the SourceId field value
// and a boolean to check if the value has been set.
func (o *ClonedTemplate) GetSourceIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.SourceId, true
}

// SetSourceId sets field value
func (o *ClonedTemplate) SetSourceId(v string) {
	o.SourceId = v
}

// GetGatewayId returns the GatewayId field value
func (o *ClonedTemplate) GetGatewayId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.GatewayId
}

// GetGatewayIdOk returns a tuple with the GatewayId field value
// and a boolean to check if the value has been set.
func (o *ClonedTemplate) GetGatewayIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.GatewayId, true
}

// SetGatewayId sets field value
func (o *ClonedTemplate) SetGatewayId(v string) {
	o.GatewayId = v
}

// GetChannelId returns the ChannelId field value
func (o *ClonedTemplate) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *ClonedTemplate) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *ClonedTemplate) SetChannelId(v string) {
	o.ChannelId = v
}

// GetSourceGatewayId returns the SourceGatewayId field value
func (o *ClonedTemplate) GetSourceGatewayId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.SourceGatewayId
}

// GetSourceGatewayIdOk returns a tuple with the SourceGatewayId field value
// and a boolean to check if the value has been set.
func (o *ClonedTemplate) GetSourceGatewayIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.SourceGatewayId, true
}

// SetSourceGatewayId sets field value
func (o *ClonedTemplate) SetSourceGatewayId(v string) {
	o.SourceGatewayId = v
}

func (o ClonedTemplate) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ClonedTemplate) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["name"] = o.Name
	toSerialize["source_id"] = o.SourceId
	toSerialize["gateway_id"] = o.GatewayId
	toSerialize["channel_id"] = o.ChannelId
	toSerialize["source_gateway_id"] = o.SourceGatewayId
	return toSerialize, nil
}

type NullableClonedTemplate struct {
	value *ClonedTemplate
	isSet bool
}

func (v NullableClonedTemplate) Get() *ClonedTemplate {
	return v.value
}

func (v *NullableClonedTemplate) Set(val *ClonedTemplate) {
	v.value = val
	v.isSet = true
}

func (v NullableClonedTemplate) IsSet() bool {
	return v.isSet
}

func (v *NullableClonedTemplate) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableClonedTemplate(val *ClonedTemplate) *NullableClonedTemplate {
	return &NullableClonedTemplate{value: val, isSet: true}
}

func (v NullableClonedTemplate) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableClonedTemplate) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


